package com.bjtdba.order.dao;

import com.bjtdba.entity.order.StoreProduct;
import com.bjtdba.order.vo.ProductXihuan;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 商品表(StoreProduct)表数据库访问层
 *
 * @author makejava
 * @since 2022-09-28 11:05:36
 */
@Repository
@Mapper
public interface StoreProductDao {

    /**
     * 通过ID查询单条数据
     *
     * @param productId 主键
     * @return 实例对象
     */
    StoreProduct queryById(Long productId);

    /**
     * 查询指定行数据
     *
     * @param storeProduct 查询条件
     * @param pageable         分页对象
     * @return 对象列表
     */
    List<StoreProduct> queryAllByLimit(StoreProduct storeProduct);

    /**
     * 统计总行数
     *
     * @param storeProduct 查询条件
     * @return 总行数
     */
    long count(StoreProduct storeProduct);

    /**
     * 新增数据
     *
     * @param storeProduct 实例对象
     * @return 影响行数
     */
    int insert(StoreProduct storeProduct);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<StoreProduct> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<StoreProduct> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<StoreProduct> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<StoreProduct> entities);

    /**
     * 修改数据
     *
     * @param storeProduct 实例对象
     * @return 影响行数
     */
    int update(StoreProduct storeProduct);

    /**
     * 通过主键删除数据
     *
     * @param productId 主键
     * @return 影响行数
     */
    int deleteById(Long productId);

    /**
     * 函数查询 子集id
     * @param cateId
     * @return
     */

    String getCateIds(Integer cateId);

    /**
     * 猜你喜欢列表
     */
    List<ProductXihuan> Productxihuan();

}

